module Repoaccessor
	require "apstrings"
	require "repoaccessor/stringsparser"
	require "repoaccessor/xmlparser"

	class Bundle
		attr_accessor :bundle_path
		attr_accessor :platform
		attr_accessor :name
		attr_accessor :resources_files
		attr_accessor :parsed
		attr_accessor :host_project

		def initialize(path,platform = "ios")
			@bundle_path = path
			@platform = platform
			@name = File.basename(path)
			@resources_files = []
			@parsed = false
			@host_project = self.host_project
		end

		def reourcefile_extention
			if @platform == "ios"
				"*.strings"
			elsif @platform == "android"
				"*.xml"
			end
		end


		def resource_file_paths
			Dir.chdir(@bundle_path)	
			files = []
			extention = reourcefile_extention
			Dir.glob(File.join("**", "#{extention}")) { |file| 
			files <<  File.expand_path(file) 
			}
			files
		end

		def host_project
			if @platform == "ios"
				p @bundle_path
				Dir.chdir(@bundle_path)
				Dir.chdir(File.expand_path("..", Dir.pwd))			
				Dir.chdir(File.expand_path("..", Dir.pwd))
				proj_name = Dir.glob("*.xcodeproj")
				if !proj_name && proj_name.empty?
					"unkonwn"
				else
					proj_name[0]
				end
			elsif @platform == "android"
				#TODO: 需要通过目录操作,找到对应的工程.
			else
				"unkonwn"
			end
		end


		def parse(args = {})
			@parsed = true
			with_comments = args[:with_comments].nil? ? false : args[:with_comments]
			if @platform == "ios"
				resource_file_paths.each { |file|
					file_hash = {}
					file_hash[:lang] = File.basename(file,".*")
					file_hash[:kv_pairs] = StringsParser::parse(file).to_hash(:with_comments => with_comments)
					@resources_files <<  file_hash
				}

			elsif @platform == "android"
				resource_file_paths.each { |file|
					file_hash = {}
					file_hash[:lang] = File.basename(file,".*")
					file_hash[:kv_pairs] = XMLParser::parse(file).to_hash(:with_comments => with_comments)
					@resources_files <<  file_hash
				}
			else
				raise "Unsupported platform"
			end

		end

		def to_hash(args={})

			if @parsed == false then
				self.parse(args)
			end
			{
				:name => @name,
				:host_project => @host_project,
				:path => @bundle_path,
				:platform => @platform,
				:parsed => @parsed,
				:resources_files => @resources_files
			}
		end

		def to_json(args={})
			self.to_hash.to_json
		end
		
	end

end