

module Repoaccessor

	require "json"
	require "repoaccessor/bundle"

	class Repo

		attr_accessor :rootpath
		attr_accessor :platform
		attr_accessor :resource_file_extention
		attr_accessor :branch_url
		attr_accessor :repo_name

		def initialize(path,platform = "ios")
			@rootpath = path
			@platform = platform
			@resource_file_extention = (platform == "ios" ? "*.strings" : "*.xml")
			@repo_name = File.basename(path,".*")
		end

		def bundle_paths
			#TODO:  这里根据platform改一下 iOS和android找不同的目录
			Dir.chdir(@rootpath)
			paths = []
			Dir.glob(File.join("**", "*.bundle")) { |file| 
			paths <<  File.expand_path(file) 
			}
			paths
		end

		def parsed_bundles
			bundles = []
			self.bundle_paths.each { 
				|path|  
				Dir.chdir(path)
				file_pattern = File.join("**", "#{@resource_file_extention}")
				resource_files =  Dir.glob(file_pattern) 
				if !resource_files.empty?
					bundles << (Bundle.new(path,@platform).to_hash())
				end
			}
			bundles
		end


		def to_hash
			{
				:repo_name => @repo_name,
				:platform  => @platform,
				:resource_file_extention => @resource_file_extention,
				:bunldes => self.parsed_bundles
			}

		end
	end
	
end
