

module Repoaccessor

	require "json"
	require "repoaccessor/bundle"

	class Repo

		attr_accessor :rootpath
		attr_accessor :platform
		attr_accessor :resource_file_extention
		attr_accessor :branch_url
		attr_accessor :repo_name

		def initialize(path,platform = "ios")
			@rootpath = path
			@platform = platform
			@resource_file_extention = (platform == "ios" ? "*.strings" : "*.xml")
		end

		def bundle_paths
			Dir.chdir(@rootpath)
			paths = []
			Dir.glob(File.join("**", "*.bundle")) { |file| 
			bundle_name = File.basename(file)
			puts " \n \n------------------"
			puts "Found #{bundle_name}...."
			puts "-------------------------" 
			paths <<  File.expand_path(file) 
			}
			paths
		end

		def parse_repo
			bundles = []
			self.bundle_paths.each { 
				|path|  
				Dir.chdir(path)
				file_pattern = File.join("**", "#{@resource_file_extention}")
				resource_files =  Dir.glob(file_pattern) 
				if !resource_files.empty?
					bundles << (Bundle.new(path,@platform).to_hash())
				end
			}
			bundles
		end
	end
	
end
