require 'yaml'

module Repoaccessor
  class Svn
    attr :repository_base
    attr :svnadmin
    attr :svn
 
    def initialize(username,pwd)
      @svn = `which svn`.strip
      @svnadmin = `which svnadmin`.strip
      @username = username
      @password = pwd
    end
 
    def commit(working_copy, message)
      `cd #{working_copy} && #{@svn} commit -m "#{message}"`
    end
 
    def add(working_copy, file)
      `cd #{working_copy} && #{@svn} add #{file}`
    end
 
    def update(working_copy)
      `cd #{working_copy} && #{@svn} up`
    end
 
    def checkout(repository, working_copy_path)
      `mkdir -p "#{working_copy_path}"`
      system "svn", "co", "#{repository}", "#{working_copy_path}", "--username", "#{@username}", "--password", "#{@password}", "--no-auth-cache", "--non-interactive" # checkout
      $?.success?
    end
 
    def info(working_copy)
      result = `#{@svn} info #{working_copy}`
      yaml = YAML.load(result)
      yaml['Revision'].to_s
    end
  end
end





